(ns com.aurellem.run.bootstrap-0
  (:use (com.aurellem.gb gb-driver vbm))
  (:use (com.aurellem.run title save-corruption))
  (:use (com.aurellem.exp item-bridge)))


(defn-memo boot-root []
  [ [] (root)])
  
(defn-memo to-rival-name
  ([] (to-rival-name (boot-root)))
  ([script]
     (-> script
         title
         oak
         name-entry-rlm
         scroll-text
         scroll-text
         scroll-text
         scroll-text
         scroll-text
         )))

(defn-memo name-rival-bootstrap
  ([] (name-rival-bootstrap (to-rival-name)))
  ([script]
     (->> script
         (advance [] [:a])
         (advance [] [:r] DE)
         (play-moves
          [[]
           [:r] [] [:r] [] [:r] [] [:r] []
           [:r] [] [:r] [] [:r] [] [:d] []
           [:d] [:a]                         ;; space
           [:l] [] [:d] [:a]                 ;; [PK]
           [:u] [] [:u] [] [:u] [] [:l] [:a] ;; G
           [:d] [] [:d] [] [:d] [] [:r] [:a] ;; [PK]
           [:u] [] [:u] [] [:u] [] [:l] [:a] ;; G
           [:d] [] [:d] [] [:d] [] [:r] [:a] ;; [PK]

           [:d] [] [:r] [:a]                 ;; finish
           ]))))

(defn walk
  "Move the character along the given directions."
  [directions script]
  (reduce (fn [script direction]
            (move direction script))
          script directions))

(def ↑ [:u])
(def ↓ [:d])
(def ← [:l])
(def → [:r])

(defn-memo leave-house
  ([] (leave-house (name-rival-bootstrap)))
  ([script]
     (->> script
          finish-title
          start-walking
          walk-to-stairs
          walk-to-door
          (walk [↓ ↓]))))

(defn-memo to-pallet-town-edge
  ([] (to-pallet-town-edge (leave-house)))
  ([script]
     (->> script
          start-walking
          (walk [→ → → → →
                 ↑ ↑ ↑ ↑ ↑ ↑]))))
     

